diff --git a/sapi/fpm/fpm/fpm_children.c b/sapi/fpm/fpm/fpm_children.c
index fdaeb89d2bf3..f30fcd62c1ba 100644
--- a/sapi/fpm/fpm/fpm_children.c
+++ b/sapi/fpm/fpm/fpm_children.c
@@ -72,6 +72,7 @@ static void fpm_child_close(struct fpm_child_s *child, int in_event_loop) /* {{{
 		if (child->fd_stdout != -1) {
 			close(child->fd_stdout);
 		}
+		fpm_event_del(&child->ev_stdout);
 	}
 
 	if (child->fd_stderr != -1) {
@@ -81,6 +82,7 @@ static void fpm_child_close(struct fpm_child_s *child, int in_event_loop) /* {{{
 		if (child->fd_stderr != -1) {
 			close(child->fd_stderr);
 		}
+		fpm_event_del(&child->ev_stderr);
 	}
 
 	fpm_child_free(child);
